Subject: 28.1; authinfo keyword smtp-auth does not work

From: John Kehayias <[email-masked]>
Date: Tue, 23 Aug 2022 22:01:10 +0000

Hello,

I have been trying to use a specific auth method for different smtp servers, which should be supported by specifying the "smpt-auth" keyword in .authinfo. However, this does not work, for any value put there (whether quoted, unquoted, etc.), Emacs always saying e.g. "Mechanism plain not implemented" when authinfo for the server contains "smtp-auth plain".

I believe the problem is that in smtpmail-try-auth-methods the smtp-auth keyword is read in by auth-source-search as a string, while the call to smtpmail-try-auth-method that uses it all match with eql, eg. as (eql 'plain).

I have tried different ways to get the smtp-auth value read differently in my authinfo, to no avail. Looking back at the devel mailing list, there was some confusion that this feature needed plstore, but in the end did not: <https://lists.gnu.org/archive/html/emacs-devel/2020-09/msg00002.html>  I can confirm that reading the authinfo does provide the smtp-auth keyword, it just won't match any method to call.

Perhaps there is a different format for specifying smtp-auth that I didn't find?

Below is the build information for my current Emacs.

Thanks!
John

In GNU Emacs 28.1 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.24.33, cairo version 1.17.6)
 of 2022-04-27 built on frederik
Windowing system distributor 'The X.Org Foundation', version 11.0.12101004
System Description: Arch Linux

Configured using:
 'configure --with-x-toolkit=gtk3 --with-native-compilation --sysconfdir=/etc
 --prefix=/usr --libexecdir=/usr/lib --localstatedir=/var --with-cairo --with-harfbuzz
 --with-libsystemd --with-modules 'CFLAGS=-march=x86-64 -mtune=generic -O2 -pipe -fno-plt
 -fexceptions -Wp,-D_FORTIFY_SOURCE=2 -Wformat -Werror=format-security
 -fstack-clash-protection -fcf-protection -g
 -ffile-prefix-map=/build/emacs/src=/usr/src/debug -flto=auto'
 'LDFLAGS=-Wl,-O1,--sort-common,--as-needed,-z,relro,-z,now -flto=auto''

Configured features:
ACL CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GPM GSETTINGS HARFBUZZ JPEG JSON LCMS2 LIBOTF
LIBSYSTEMD LIBXML2 M17N_FLT MODULES NATIVE_COMP NOTIFY INOTIFY PDUMPER PNG RSVG SECCOMP
SOUND THREADS TIFF TOOLKIT_SCROLL_BARS X11 XDBE XIM XPM GTK3 ZLIB

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Memory information:
((conses 16 1068719 151325)
 (symbols 48 57665 0)
 (strings 32 248488 6921)
 (string-bytes 1 8756410)
 (vectors 16 122100)
 (vector-slots 8 2564346 97616)
 (floats 8 1553 949)
 (intervals 56 22635 2271)
 (buffers 992 40))